Create an AI custom ruleset

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

POST https://api.ap1.datadoghq.com/api/v2/static-analysis/ai/rulesetshttps://api.ap2.datadoghq.com/api/v2/static-analysis/ai/rulesetshttps://api.datadoghq.eu/api/v2/static-analysis/ai/rulesetshttps://api.ddog-gov.com/api/v2/static-analysis/ai/rulesetshttps://api.us2.ddog-gov.com/api/v2/static-analysis/ai/rulesetshttps://api.datadoghq.com/api/v2/static-analysis/ai/rulesetshttps://api.us3.datadoghq.com/api/v2/static-analysis/ai/rulesetshttps://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets

Overview

Create a new AI custom ruleset for the authenticated organization.

Request

Body Data (required)

Expand All

Field

Type

Description

data

object

Request data for creating an AI custom ruleset.

attributes

object

Attributes for creating an AI custom ruleset.

description [required]

string

Base64-encoded full description of the ruleset.

name [required]

string

The ruleset name.

short_description [required]

string

Base64-encoded short description of the ruleset.

id

string

The ruleset identifier, which must match the name.

type

enum

AI custom ruleset resource type. Allowed enum values: ai_ruleset

{
  "data": {
    "attributes": {
      "description": "Ruleset description",
      "name": "my-ai-ruleset",
      "short_description": "Ruleset short description"
    },
    "id": "my-ai-ruleset",
    "type": "ai_ruleset"
  }
}

Response

Successfully created

Response containing a single AI custom ruleset.

Expand All

Field

Type

Description

data [required]

object

Response data for an AI custom ruleset.

attributes [required]

object

Response attributes of an AI custom ruleset.

created_at [required]

date-time

The creation timestamp.

created_by [required]

string

The identifier of the user who created the ruleset.

description [required]

string

Base64-encoded full description of the ruleset.

name [required]

string

The ruleset name.

rules [required]

[object]

The rules contained in the ruleset.

created_at [required]

date-time

The creation timestamp.

created_by [required]

string

The identifier of the user who created the rule.

last_revision [required]

object

The most recent revision of the rule.

category [required]

enum

Rule category Allowed enum values: SECURITY,BEST_PRACTICES,CODE_STYLE,ERROR_PRONE,PERFORMANCE

checksum [required]

string

Checksum of the revision content.

content [required]

string

Base64-encoded AI model content for this revision.

created_at [required]

date-time

The creation timestamp.

created_by [required]

string

The identifier of the user who created the revision.

cwe [required]

string

The associated CWE identifier.

description [required]

string

Base64-encoded full description.

directories [required]

[string]

Directory patterns this rule applies to.

execution_mode [required]

enum

The execution mode for an AI rule revision. Allowed enum values: auto,manual,always

globs [required]

[string]

File glob patterns this rule applies to.

is_default [required]

boolean

Whether this is a default Datadog rule.

is_published [required]

boolean

Whether this revision is published.

is_testing [required]

boolean

Whether this revision is for testing only.

severity [required]

enum

Rule severity Allowed enum values: ERROR,WARNING,NOTICE

short_description [required]

string

Base64-encoded short description.

version_id [required]

int64

The version identifier for this revision.

name [required]

string

The rule name.

short_description [required]

string

Base64-encoded short description of the ruleset.

id [required]

string

The ruleset identifier.

type [required]

enum

AI custom ruleset resource type. Allowed enum values: ai_ruleset

{
  "data": {
    "attributes": {
      "created_at": "2024-01-01T00:00:00+00:00",
      "created_by": "example-handle",
      "description": "Ruleset description",
      "name": "my-ai-ruleset",
      "rules": [
        {
          "created_at": "2024-01-01T00:00:00+00:00",
          "created_by": "example-handle",
          "last_revision": {
            "category": "SECURITY",
            "checksum": "abc123def456",
            "content": "Content",
            "created_at": "2024-01-01T00:00:00+00:00",
            "created_by": "example-handle",
            "cwe": "79",
            "description": "Ruleset description",
            "directories": [
              []
            ],
            "execution_mode": "auto",
            "globs": [
              "**/*.py"
            ],
            "is_default": false,
            "is_published": false,
            "is_testing": false,
            "severity": "ERROR",
            "short_description": "Ruleset short description",
            "version_id": 1
          },
          "name": "my-ai-rule"
        }
      ],
      "short_description": "Ruleset short description"
    },
    "id": "my-ai-ruleset",
    "type": "ai_ruleset"
  }
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Unauthorized

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Conflict - ruleset already exists

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Precondition Failed - validation error

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Internal Server Error

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Code Example

                  ## default
# 

# Curl command
curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "description": "Ruleset description", "name": "my-ai-ruleset", "short_description": "Ruleset short description" }, "id": "my-ai-ruleset", "type": "ai_ruleset" } } EOF